// #autoload
// #name = chadz' Ingame Tactics Designer
// #description = Lets you make tactics ingame with a GUI
// #readme = scripts/chadz/czTactics.txt
// #version = 1.0
// #category = chadz' scripts
// #author = -Spider-chadz
// #warrior = chadz
// #email = shadowalker@teamspider.org
// #web = http://macbeth.loves.teamspider.org
// #include = support/team_tracker.cs

$czTacticsText = "?tactics";
$czTacticsSpamOnRequest = 1;

package czTacticsScreen
{

function OptionsDlg::onWake(%this)
{
	if (!$czTacticsOptions)
	{
		$RemapName[$RemapCount] = "Tactics Screen";
		$RemapCmd[$RemapCount]  = "czTacticsLoad";
		$RemapCount++;

		$czTacticsOptions = true;
	}

	parent::onWake(%this);
}



function addMessageHudLine(%text)
        {	
		if($czTacticsSpamOnRequest)
			{
			if(strStr(%text, $czTacticsText) != -1) czSayNameList($czTacticsSpamType);
			}
        	
       	parent::addMessageHudLine(%text);
        }



};
activatePackage(czTacticsScreen);




	
	
function czGetNameList(){
$czmyTeamCount = 0;
$czTeamNames = "";
%czmyteam = teamtracker.friendlyTeamID;
%count = PlayerListGroup.getCount();

	for(%i = 1; %i <= 16; %i++) $czTeamNames[%i] = "";
	
	for(%i = 0; %i < %count; %i++)
	{
		%obj = PlayerListGroup.getObject(%i);
		if (%obj.teamID == %czmyteam)
			{
				$czMyTeamCount++;
				$czTeamNames[$czMyTeamCount] = %obj.name;
				
			}
		
	
	}
	

}

function czSayNameList(%type){
if(%type == 1){
	$czTacticsSpamType = 1;
	for(%i = 1; %i <= $czMyTeamCount; %i++)
		{
			commandToServer('TeamMessageSent', "\c1@@\c2"@$czTeamNames[%i]@": \c5"@$czTeamPositions[%i]);
		}	
}

else if(%type == 2){
	$czTacticsSpamType = 2;
	%chars = 120;
	%j = 0;
	$czTacticsMessage[0] = "";
	$czTacticsMessage[1] = "";
	$czTacticsMessage[2] = "";
	$czTacticsMessage[3] = "";
	
		for(%i = 1; %i <= $czMyTeamCount; %i++)
		{
			%string = "\c1@@\c2"@$czTeamNames[%i]@": \c5"@$czTeamPositions[%i] @ ", ";
			%stringcombined = $czTacticsMessage[%j] @ %string;
			%stringlength = strLen(%stringcombined);
			if (%stringlength > %chars) 
			{ 
				%j++; 
				%string = "";
				%stringcombined = "";
				%stringlength = "";
			}
			$czTacticsMessage[%j] = %stringcombined;
		}	


		for(%i = 0; %i < 4; %i++)
		{
			if (strlen($czTacticsMessage[%i]) > 0) commandToServer('TeamMessageSent', $czTacticsMessage[%i]);
				
		}

	
}	
}

function czTacticsTextUpdate(){
	
$czTeamNames[1] = czTacticsName1.getvalue();
$czTeamNames[2] = czTacticsName2.getvalue();
$czTeamNames[3] = czTacticsName3.getvalue();
$czTeamNames[4] = czTacticsName4.getvalue();
$czTeamNames[5] = czTacticsName5.getvalue();
$czTeamNames[6] = czTacticsName6.getvalue();
$czTeamNames[7] = czTacticsName7.getvalue();
$czTeamNames[8] = czTacticsName8.getvalue();
$czTeamNames[9] = czTacticsName9.getvalue();
$czTeamNames[10] = czTacticsName10.getvalue();
$czTeamNames[11] = czTacticsName11.getvalue();
$czTeamNames[12] = czTacticsName12.getvalue();
$czTeamNames[13] = czTacticsName13.getvalue();
$czTeamNames[14] = czTacticsName14.getvalue();
$czTeamNames[15] = czTacticsName15.getvalue();
$czTeamNames[16] = czTacticsName16.getvalue();

$czTeamPositions[1] = czTacticsPos1.getvalue();
$czTeamPositions[2] = czTacticsPos2.getvalue();
$czTeamPositions[3] = czTacticsPos3.getvalue();
$czTeamPositions[4] = czTacticsPos4.getvalue();
$czTeamPositions[5] = czTacticsPos5.getvalue();
$czTeamPositions[6] = czTacticsPos6.getvalue();
$czTeamPositions[7] = czTacticsPos7.getvalue();
$czTeamPositions[8] = czTacticsPos8.getvalue();
$czTeamPositions[9] = czTacticsPos9.getvalue();
$czTeamPositions[10] = czTacticsPos10.getvalue();
$czTeamPositions[11] = czTacticsPos11.getvalue();
$czTeamPositions[12] = czTacticsPos12.getvalue();
$czTeamPositions[13] = czTacticsPos13.getvalue();
$czTeamPositions[14] = czTacticsPos14.getvalue();
$czTeamPositions[15] = czTacticsPos15.getvalue();
$czTeamPositions[16] = czTacticsPos16.getvalue();

for(%i = 1; !%czFoundEmpty; %i++){
if (!strlen($czTeamNames[%i]) > 0)
	{
	$czmyTeamCount = %i - 1;
	%czFoundEmpty = true;
	
	}
}

	
	
}



function czTacticsLoad(%val){
	
	
	
	
	if(%val){
	canvas.pushdialog($czTactics);	
	}
if ($czTacticsFirstLoad) czGetNameList();

$czTacticsFirstLoad = false;
	
czTacticsSpamRequest.setvalue($czTacticsSpamOnRequest);	
czTacticsName1.settext($czTeamNames[1]);
czTacticsName2.settext($czTeamNames[2]);
czTacticsName3.settext($czTeamNames[3]);
czTacticsName4.settext($czTeamNames[4]);
czTacticsName5.settext($czTeamNames[5]);
czTacticsName6.settext($czTeamNames[6]);
czTacticsName7.settext($czTeamNames[7]);
czTacticsName8.settext($czTeamNames[8]);
czTacticsName9.settext($czTeamNames[9]);
czTacticsName10.settext($czTeamNames[10]);
czTacticsName11.settext($czTeamNames[11]);
czTacticsName12.settext($czTeamNames[12]);
czTacticsName13.settext($czTeamNames[13]);
czTacticsName14.settext($czTeamNames[14]);
czTacticsName15.settext($czTeamNames[15]);
czTacticsName16.settext($czTeamNames[16]);

czTacticsPos1.settext($czTeamPositions[1]);
czTacticsPos2.settext($czTeamPositions[2]);
czTacticsPos3.settext($czTeamPositions[3]);
czTacticsPos4.settext($czTeamPositions[4]);
czTacticsPos5.settext($czTeamPositions[5]);
czTacticsPos6.settext($czTeamPositions[6]);
czTacticsPos7.settext($czTeamPositions[7]);
czTacticsPos8.settext($czTeamPositions[8]);
czTacticsPos9.settext($czTeamPositions[9]);
czTacticsPos10.settext($czTeamPositions[10]);
czTacticsPos11.settext($czTeamPositions[11]);
czTacticsPos12.settext($czTeamPositions[12]);
czTacticsPos13.settext($czTeamPositions[13]);
czTacticsPos14.settext($czTeamPositions[14]);
czTacticsPos15.settext($czTeamPositions[15]);
czTacticsPos16.settext($czTeamPositions[16]);
	
}

$czTacticsFirstLoad = true;


//--- OBJECT WRITE BEGIN ---
$czTactics = new GuiControl(czTactics) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(czTacticsPane) {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "450 100";
		extent = "512 570";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
		
		new HudBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "17 25";
			extent = "478 529";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fillColor = "0.000000 0.000000 0.000000 1.000000";
			frameColor = "0.000000 0.000000 0.000000 1.000000";
			opacity = "1";
			autoCenter = "0";
			autoResize = "0";
			flipVertical = "0";
			flipHorizontal = "0";
			wrap = 1;

		};

		new ShellTextEditCtrl(czTacticsName1) {
			position = "32 36";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos1) {
			position = "220 36";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName2) {
			position = "32 66";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos2) {
			position = "220 66";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName3) {
			position = "32 96";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos3) {
			position = "220 96";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName4) {
			position = "32 126";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos4) {
			position = "220 126";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName5) {
			position = "32 156";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos5) {
			position = "220 156";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName6) {
			position = "32 186";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos6) {
			position = "220 186";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName7) {
			position = "32 216";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos7) {
			position = "220 216";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName8) {
			position = "32 246";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos8) {
			position = "220 246";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName9) {
			position = "32 276";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos9) {
			position = "220 276";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName10) {
			position = "32 306";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos10) {
			position = "220 306";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName11) {
			position = "32 486";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos11) {
			position = "220 486";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName12) {
			position = "32 336";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos12) {
			position = "220 336";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName13) {
			position = "32 366";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos13) {
			position = "220 366";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName14) {
			position = "32 396";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos14) {
			position = "220 396";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName15) {
			position = "32 426";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos15) {
			position = "220 426";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsName16) {
			position = "32 456";
			extent = "198 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		new ShellTextEditCtrl(czTacticsPos16) {
			position = "220 456";
			extent = "264 38";
			command = "czTacticsTextUpdate();";
			maxLength = "255";
		};
		
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 520";
			extent = "110 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "czSayNameList(1);canvas.popdialog($cztactics);";
			helpTag = "0";
			text = "Say Team (Flood)";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "110 520";
			extent = "120 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "czSayNameList(2);canvas.popdialog($cztactics);";
			helpTag = "0";
			text = "Say Team (Compact)";
			simpleStyle = "0";
		};
		new ShellToggleButton(czTacticsSpamRequest) {
			horizSizing = "right";
			vertSizing = "bottom";
			position = "220 525";
			extent = "100 38";
			minExtent = "32 38";
			visible = "1";
			variable = "$czTacticsSpamOnRequest";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Enble Request";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "405 520";
			extent = "93 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			command = "canvas.popdialog($cztactics);";
			text = "Exit";
			simpleStyle = "0";
		};
	
		new ShellBitmapButton(b4) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "334 520";
			extent = "84 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "czGetNameList();czTacticsLoad();";
			helpTag = "0";
			text = "Update List";
			simpleStyle = "0";
		};
	};
    
};
//--- OBJECT WRITE END ---


